//
// 訢    AD9850
//  16x2, 20x1, 20x2
// : 㫥订 .. (2003 )
//

char arga[4];
char argb[4];
char BCD[8];   //祭  ࠭  BCD
char cursor=0; // 
char mode=0;   // 0=work  1=edit  2=edit_zero
char fpos=0;
char t,i,j,jj,p,pp;

// ⠭, 騥  ⠪⮢  (CLK)
// m - ᫮, 饥 ᨬ쭮   (32 )
// mk1*mk2=4294967296/CLK - ⥫  祭 ࠢ饣 ᫮ 

// ⠭  ⠪⮢  CLK=120000000 

#define mk1 1
#define mk2 36

char m[4]={0x00,0x87,0x93,0x03};

////////////////////////////////////////////////
//                  EEPROM
////////////////////////////////////////////////

void loadBCD()          //㧪 BCD+cursor  EEPROM
     {
     for (i=0;i<9;i++)  
         {
         EEADR = i;
         set_bit( STATUS, RP0 );
         set_bit( EECON1, RD );
         clear_bit( STATUS, RP0 );
         BCD[i]=EEDATA;
         }     
     }

void saveBCD()          //࠭ BCD+cursor  EEPROM
     {
     for (i=0;i<9;i++)
         {
         EEADR = i;
         EEDATA = BCD[i];
     
         set_bit( STATUS, RP0 );
         set_bit( EECON1, WREN );
         EECON2 = 0x55;
         EECON2 = 0xAA;
         set_bit( EECON1, WR );
         while(EECON1&2);
         clear_bit( EECON1, WREN );
     
         clear_bit( STATUS, RP0 );
         }
     }


////////////////////////////////////////////////
//                  Pauses
////////////////////////////////////////////////

void wait2()                     //প 
     {
     for (j=0;j<40;j++)
         for (i=0;i<240;i++) nop();
     }


////////////////////////////////////////////////
//                ⥬⨪
////////////////////////////////////////////////

void add() //arga+=argb;   i,p,pp
     {
     p=0;
     for (i=0;i<4;i++)
         {
         pp=0;
         t=arga[i];
         if (255-t<p) pp=1;
         if (p) t++;
         if (255-t<argb[i]) pp=1;
         arga[i]=t+argb[i];
         p=pp;
         }
     }

void shl() //arga=arga<<1;   i,p,pp
     {
     p=0;
     for (i=0;i<4;i++)
         {
         pp=0;
         t=arga[i];
         if (t&0x80) pp=1; 
         t<<=1;
         if (p) t++;
         arga[i]=t;
         p=pp;
         }
     }

void mul10() //arga*=10;   i,p,pp,argb
     {
     for (i=0;i<4;i++) argb[i]=arga[i];
     shl();
     shl();
     add();
     shl();
     }

void BCDbin()  //arga=f(BCD)  i,j,p,pp,argb
     {
     for (i=0;i<4;i++) arga[i]=0;
     for (j=0;j<8;j++)
         {
         mul10();
         for (i=1;i<4;i++) argb[i]=0;
         argb[0]=BCD[7-j];
         add();
         }
     }

void mulk() //arga*=k;   i,p,pp,argb
     {
     for (i=0;i<4;i++) argb[i]=arga[i];
     for (jj=0;jj<mk1;jj++)
         for (j=1;j<mk2;j++) add();
     }

////////////////////////////////////////////////
//               LCD procedures
////////////////////////////////////////////////
void waitLCD()
     {
     char data=0xff;
     set_bit(STATUS,RP0);       //᪮䨣஢   LCD
     TRISB=0xFF;                // B  IIIIIIII
     clear_bit(STATUS,RP0);
     while (data&8)
        {
        clear_bit(PORTA,0);                                 //RS
        set_bit(PORTA,1);                                   //RW=1
        set_bit(PORTA,2);                                   //E=1
        data=PORTB;
        clear_bit(PORTA,2);                                 //=0
        set_bit(PORTA,2);                                   //E=1
        clear_bit(PORTA,2);                                 //=0
        }
     set_bit(STATUS,RP0);       //᪮䨣஢ 뢮  LCD
     TRISB=0xF0;                // B  IIIIOOOO
     clear_bit(STATUS,RP0);
     }

void writeLCD(char rs,char data)//뢮  LCD
     {
     waitLCD();
     if (rs) set_bit(PORTA,0); else clear_bit(PORTA,0);  //RS
     clear_bit(PORTA,1);                                 //RW=0
     PORTB=(data>>4)|0x10;
     set_bit(PORTA,2);                                   //E=1
     clear_bit(PORTA,2);                                 //=0
     PORTB=data|0x10;
     set_bit(PORTA,2);                                   //E=1
     clear_bit(PORTA,2);                                 //=0
     }

void outsymLCD(char sym) {writeLCD(1,sym);}   //뢮   LCD
void outcomLCD(char cmd) {writeLCD(0,cmd);}   //뢮   LCD
void clearLCD()   {outcomLCD(0x01);}          //⪠ LCD
//void scrollLCDr() {outcomLCD(0x1c);}        //ப⪠ LCD ࠢ
//void scrollLCDl() {outcomLCD(0x18);}          //ப⪠ LCD 
void cursorposLCD(char pos) {outcomLCD(0x80+pos);} //樮஢  LCD 
//controlLCD  0x08+param (00001|display|cursor|blink)
//modesetLCD  0x04+param (000001|direction|scroll)

////////////////////////////////////////////////
//               INIT procedures
////////////////////////////////////////////////

void InitPIC()                  //樠 ⮢ /뢮
     {
     set_bit(STATUS,RP0);
     TRISA=0x0;                 // A     OOOOO
     TRISB=0xF0;                // B  IIIIOOOO
     OPTION_REG=0x0;            //㫠  B 
     INTCON=0;                  //GIE=0 
     clear_bit(STATUS,RP0);     
     PORTA=0x10;
     PORTB=0x0;
     }

void InitLCD()                  //樠 LCD
     {
     waitLCD();
     outcomLCD(0x30);           //䨣
     outcomLCD(0x20);           //4- ⭮
     outcomLCD(0x28);           //
     outcomLCD(8+4);            //controlLCD
     outcomLCD(4+2);            //modesetLCD
     }

////////////////////////////////////////////////
//                  DDS
////////////////////////////////////////////////

void outDDS() //뢮 arga  DDS
     {
     mulk();
     for (j=0;j<5;j++)
         {
         p=arga[j];
         if (j==4) p=0;
         for (i=0;i<8;i++)
             {
             if (p&1) set_bit(PORTB,0); else clear_bit(PORTB,0);
             p>>=1;
             set_bit(PORTB,1);          //W_CLK=1
             clear_bit(PORTB,1);        //W_CLK=0
             }
         }
     set_bit(PORTA,3);                  //FQ_UD=1
     clear_bit(PORTA,3);                //FQ_UD=0
     }

////////////////////////////////////////////////
//                  Keyboard
////////////////////////////////////////////////

char getkey() //᫥⥫  ⮫殢 
     {
     asm
        {
        movlw 0x1
        btfss PORTB,4 
        return
        movlw 0x4
        btfss PORTB,5 
        return
        movlw 0x7
        btfss PORTB,6 
        return
        movlw 0xA
        btfss PORTB,7 
        return
        clrw
        return
        }
     }

char scankey()          // 室 -  
     {
     PORTB=0xF7;               
     p=getkey();
     if (p) return p+20;
     PORTB=0xFB;          
     p=getkey();
     if (p) return p+2;
     PORTB=0xFD;          
     p=getkey();
     if (p) return p+1;
     PORTB=0xFE;
     p=getkey();
     if (p) return p;
     return 0xFF;       //祣  
     }

////////////////////////////////////////////////
//                  BCD buffer
////////////////////////////////////////////////

void outBCD()           //뢮 ᫠  LCD
     {
     clearLCD();
     cursorposLCD(0);
     outsymLCD('F');
     outsymLCD('=');
     for (j=0;j<8;j++)
         outsymLCD(BCD[7-j]+'0');
     cursorposLCD(11);    
     outsymLCD('H');
     outsymLCD('z');     
     }
     
void clearBCD()         //BCD=0
     {
     for (j=0;j<8;j++) BCD[j]=0;
     }

void BCDinc()           //㢥祭 ࠧ鸞  1
     {
     for (i=cursor;i<7;i++)
         {
         BCD[i]=BCD[i]+1;
         if (BCD[i]==10) BCD[i]=0;else break;
         }
     }

void BCDdec()           //㬥襭 ࠧ鸞  1
     {
     for (i=cursor;i<7;i++)
         {
         BCD[i]=BCD[i]-1;
         if (BCD[i]==0xFF) BCD[i]=9;else break;
         }
     }

////////////////////////////////////////////////
//                  Misc
////////////////////////////////////////////////

char validvalue()  //஢ઠ  讥 祭
     {
     j=3;
     for (i=0;i<4;i++)
         {
         if (arga[j]>m[j]) return 0;
         if (arga[j]<m[j]) return 1;
         j--;
         } 
     }

void showcursor()  // 
     {
     outcomLCD(8+7);     
     cursorposLCD(9-cursor);
     wait2();     
     outcomLCD(8+4);     
     }

void work()        //楤 ᭮ 横
     {
     i=scankey();
     if (i==11) i=0; 
     
     if (i<27) clear_bit(PORTA,4); //sound on
     if (i<10)          //digit key
        {
        if (!(mode))
           {
           clearBCD();
           outBCD();
           }
        mode=1;           
        if (BCD[7]==0)
           {
           for (j=0;j<7;j++) BCD[7-j]=BCD[6-j];
           BCD[0]=i;
           outBCD();
           wait2();
           }
        }

     if (i==10)         //clear key
        {
        clearBCD();
        if (mode==2)
           {
           mode=0;
           loadBCD();
           }
        else mode=2;
        outBCD();
        wait2();   
        }
        
     if (i==12)         //enter key
        {
        BCDbin();
        clearLCD();
        if (validvalue())
           {
           outDDS();
           saveBCD();
           mode=0;
           cursorposLCD(6);
           outsymLCD('[');                
           outsymLCD('O');                        
           outsymLCD('K');                
           }
        else
           {
           cursorposLCD(4);
           outsymLCD('[');                
           outsymLCD('E');                        
           outsymLCD('r');                
           outsymLCD('r');                           
           outsymLCD('o');                
           outsymLCD('r');                           
           }
        outsymLCD(']');                        
        wait2();

        outBCD();
        }

     if (i==21)         //right key
        {
        if (cursor>0) cursor--;
        showcursor();
        }

     if (i==24)         //left key
        {
        if (cursor<7) cursor++;
        showcursor();
        }
        
     if (i==27)         //up key
        {
        BCDinc();
        BCDbin();        
        if (validvalue())
           {
           outDDS();
           saveBCD();
           outBCD();
           }
        else loadBCD();
        }
     if (i==30)         //down key
        {
        BCDdec();
        BCDbin();        
        if (validvalue())
           {
           outDDS();
           saveBCD();
           outBCD();
           }
        else loadBCD();
        }
        
     set_bit(PORTA,4);  //sound off
     }


////////////////////////////////////////////////
//                  Main()
////////////////////////////////////////////////

void main()
     {

     InitPIC();
     InitLCD();
     
     loadBCD();
     BCDbin();
     outDDS();
     outBCD();
     
     for (;;)
         {
         work();

         if (!(mode))           // 窨
            {
            fpos++;
            cursorposLCD(15);
            if (fpos==0) outsymLCD('*');
            if (fpos==0x80) outsymLCD(' ');            
            }
  
         }
     
     }
     
     

     